// HTTPServerDlg.h : header file
//

#if !defined(AFX_HTTPSERVERDLG_H__261571D8_35BC_42EB_BEE7_F08E141BF751__INCLUDED_)
#define AFX_HTTPSERVERDLG_H__261571D8_35BC_42EB_BEE7_F08E141BF751__INCLUDED_

#include "ServerThread.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <shlobj.h>
#include <shlwapi.h>
#include "DlgMessage.h"
#include "CmdLineA.h"
#include "afxtempl.h"

typedef CList<int, int> INTLIST;

/////////////////////////////////////////////////////////////////////////////
// CHTTPServerDlg dialog

class CHTTPServerDlg : public CDialog
{
// Construction
public:
	CHTTPServerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CHTTPServerDlg)
	enum { IDD = IDD_HTTPSERVER_DIALOG };
	CListBox	m_listMonitor;
	CString	m_sBasePath;
	UINT	m_iPort;
	CString	m_sPasswordFile;
	CString	m_sDefaultPage;
	BOOL	m_fRecToMon;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHTTPServerDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
// Public members
public:
	static bool CompleteStringToLong(LPCTSTR, long *);
	INTLIST m_rdOnlyItemList; // read-only item list
	INTLIST m_IDList; // ID list
	enum CurrentStateConstants { csStopped, csRunning, csStopping };

// Protected member variables
protected:
	HICON m_hIcon;
	HICON m_hIconSmall;
	STHREAD_INFO m_sThreadInfo;
	CString *m_sarrPasswords;
	int m_iPasswordCount;
	bool m_fStopping;
	enum CurrentStateConstants m_curState;

// Protected member functions
protected:
	afx_msg LRESULT OnThreadFinished(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT On_MYWM_NOTIFYICON(WPARAM wParam, LPARAM lParam);
	HICON LoadSmallIcon();
	afx_msg LRESULT OnTaskbarRestarted(WPARAM wParam, LPARAM lParam);
	void AddMainTaskbarIcon();
protected:
	afx_msg LRESULT OnMonitorAddString(WPARAM w, LPARAM l);
	bool m_usingNotifyIcon;
	CFont m_mnFnt; // main font
	bool ReadPasswords(void);
	// Generated message map functions
	//{{AFX_MSG(CHTTPServerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnBasepath();
	afx_msg void OnBtnPasswords();
	afx_msg void OnBtnPasswordfile();
	afx_msg void OnBtnStop();
	afx_msg void OnBtnClearmonitor();
	afx_msg void OnDblclkListMonitor();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnBtnStart();
	afx_msg void OnBtnHide();
	afx_msg void OnChkRecToMon();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

BOOL MyTaskBarAddIcon(HWND hwnd, UINT uID, HICON hicon, LPCTSTR lpszTip);
BOOL MyTaskBarDeleteIcon(HWND hwnd, UINT uID);

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HTTPSERVERDLG_H__261571D8_35BC_42EB_BEE7_F08E141BF751__INCLUDED_)
